#include <iostream>
#include <iomanip>
#include <vector>
#include <cmath>

using namespace std;

const long double EPS = 1e-9;

int main() {
	ios_base::sync_with_stdio(0);
	cout.tie(0);
	
	int n;
	cin >> n;
	
	vector <pair <long double, long double>> inp(n);
	vector <long double> a(n - 1), b(n - 1);
	vector <long double> dif(n - 1);
	for (int i = 0; i < n; i++) {
		cin >> inp[i].first >> inp[i].second;
		
		if (i) dif[i - 1] = (inp[i].second - inp[i - 1].second) / (inp[i].first - inp[i - 1].first);
		if (i < n - 1) b[i] = -inp[i].first;
	}
	
	a[0] = dif[0];
	for (int i = 1; i < n - 1; i++) {
		a[i] = (dif[i] - dif[i - 1]) / 2.0;
		b[i] = abs(a[i]) * b[i];
		a[0] += a[i];
	}
	b[0] *= abs(a[0]);
	
	long double fix = 0.0, sum = 0.0;
	for (int i = 0; i < n - 1; i++) {
		long double add = abs(abs(a[i]) * inp[0].first + b[i]);
		if (a[i] < -EPS)
			add *= -1.0;
		sum += add;
	}
	
	fix = inp[0].second - sum;
	
	cout.precision(9);
	for (int i = 0; i < n - 1; i++) {
		if (a[i] < -EPS) cout << '-';
		else if (i) cout << '+';
		cout << '|';
		cout << fixed << abs(a[i]);
		cout << 'x';
		if (b[i] > -EPS) cout << '+';
		else cout << '-';
		cout << fixed << abs(b[i]);
		cout << '|';
	}
	
	if (fix > -EPS) cout << '+';
	else cout << '-';
	cout << "|0x+";
	cout << abs(fix) << '|';
	
	return 0;
}