#define _CRT_SECURE_NO_WARNINGS
#include <iostream>
#include <cstdlib>
#include <cstdio>
#include <tuple>
#include <vector>
using namespace std;

double calc(const vector<tuple<bool, double, double>>& ans, double x)
{
    double res = 0;
    for (const auto& e : ans)
    {
        bool a;
        double b, c;
        tie(a, b, c) = e;
        if (a)
            res += abs(b * x + c);
        else
            res -= abs(b * x + c);
    }
    return res;
}

int main()
{
    int n;
    scanf("%d", &n);
    vector<pair<int, int>> inp(n);
    for (int i = 0; i < n; ++i)
        scanf("%d %d", &inp[i].first, &inp[i].second);

    vector<tuple<bool, double, double>> ans;
    double prev_slant = (double)(inp[1].second - inp[0].second) / (inp[1].first - inp[0].first);
    for (int i = 1; i + 1 < n; ++i)
    {
        double cur_slant = (double)(inp[i + 1].second - inp[i].second) / (inp[i + 1].first - inp[i].first);
        ans.emplace_back(cur_slant > prev_slant,
                         (cur_slant - prev_slant) / 2,
                         (cur_slant - prev_slant) / 2 * -inp[i].first);
        prev_slant = cur_slant;
    }
    double x1 = inp.front().first;
    double y1 = calc(ans, x1) - inp.front().second;
    double x2 = inp.back().first;
    double y2 = calc(ans, x2) - inp.back().second;
    double slant = (y1 - y2) / (x1 - x2);
    ans.emplace_back(slant > 0, slant, slant * -(inp.back().first + 1));

     y1 = calc(ans, x1) - inp.front().second;
     y2 = calc(ans, x2) - inp.back().second;
     slant = (y1 - y2) / (x1 - x2);

    double c = inp.front().second - calc(ans, inp.front().first);
    ans.emplace_back(c > 0, 0, c);

    for (int i = 0; i < n; ++i)
    {
        bool a;
        double b, c;
        tie(a, b, c) = ans[i];
        if (!a)
            putchar('-');
        else if (i)
            putchar('+');
        printf("|%.12lfx", b);
        if (c >= 0)
            printf("+%.12lf|", abs(c));
        else
            printf("-%.12lf|", abs(c));
    }
    putchar('\n');
}