#include "testlib.h"
#include <vector>
#include <set>
#include <functional>

using namespace std;

int main(int argc, char* argv[]) {
	registerValidation(argc, argv);
	
	int n = inf.readInt(2, 100'000, "n");
	inf.readSpace();
	int m = inf.readInt(1, 100'000, "m");
	inf.readSpace();
	int q = inf.readInt(1, 100'000, "q");
	inf.readEoln();
	
	vector <vector <int>> g(n, vector <int>(0));
	set <pair <int, int>> st;
	for (int i = 0; i < m; i++) {
		int u = inf.readInt(1, n, "u");
		inf.readSpace();
		int v = inf.readInt(1, n, "v");
		inf.readSpace();
		int s = inf.readInt(1, 1'000'000'000, "s");
		inf.readSpace();
		int w = inf.readInt(1, 1'000'000'000, "w");
		inf.readEoln();
		
		u--, v--;
		
		ensuref(u != v, "no loops");
		ensuref(st.count({ u, v }) == 0, "no repeats");
		st.insert({ u, v });
		
		g[u].push_back(v);
	}
	
	bool dag = true;
	vector <int> used(n, 0);
	
	function <bool(int)> dfs = [&](int v) {
		used[v] = 1;
		for (auto to : g[v])
			if (used[to] == 0) {
				if (!dfs(to))
                    return false;
			}
			else if (used[to] == 1)
				return false;
		used[v] = 2;
		return true;
	};
	
	for (int i = 0; i < n; i++) {
		if (!used[i])
			dag &= dfs(i);
	}
	
	ensuref(dag, "no cycles");
	
	for (int i = 0; i < q; i++) {
		int a = inf.readInt(1, 1'000'000'000, "a");
		inf.readSpace();
		int b = inf.readInt(1, 1'000'000'000, "b");
		inf.readEoln();
	}
	
	inf.readEof();
	
	return 0;
}