import functools
import io
import os


def comp(a, b):
    return a[1] * b[0] - a[0] * b[1]


def main():
    input = io.BytesIO(os.read(0, os.fstat(0).st_size)).readline
    n, m, q = map(int, input().decode().split())

    graph = [[] for i in range(n)]
    sorted_sw = []
    in_deg = [0] * n
    
    for i in range(m):
        u, v, s, w = map(int, input().decode().split())
        u = u - 1
        v = v - 1
        in_deg[v] += 1
        graph[u].append([v, s, w]) 
        sorted_sw.append((s, w))

    sorted_sw.sort(key = functools.cmp_to_key(comp))
    sorted = {}
    for i, e in enumerate(sorted_sw):
        sorted[e] = i
    for i in range(n):
        graph[i] = [(v, sorted[(s, w)]) for v, s, w in graph[i]]

    stack = [i for i, e in enumerate(in_deg) if e == 0]
    dp = [m] * n
    dp[0] = 0
    while stack:
        v = stack.pop()
        for u, c in graph[v]:
            dp[u] = min(dp[u], max(dp[v], c))
            in_deg[u] -= 1
            if in_deg[u] == 0:
                stack.append(u)

    s, w = sorted_sw[dp[n - 1]] if dp[n - 1] < m else (0, 1)
    for i in range(q):
        a, b = map(int, input().decode().split())
        if a * s > b * w:
            print('YES')
        else:
            print('NO')


if __name__ == '__main__':
    main()
